component-section
  div(slot='title') #️ Hashen
  component-section
    div(slot='title') Waarom je over hashen leert
    p.praktijk
      | Hashverzamelingen zijn de standaardwijze waarop verzamelingen worden geïmplementeerd in de meeste programmeertalen, zeker als het om generieke itemtypes gaat.
      | Overal waar je aan de hand van een sleutel één of meer waardes wilt kunnen opzoeken, dus de vele plaatsen waar je associatieve rijen gebruikt, zijn hashtabellen de gangbaarste oplossing.
      | Hashtabellen worden gebruikt om bijvoorbeeld elk van grote aantallen URL-paden door te leiden naar web views (URL routers).
      | Cryptografische hashalgoritmes worden gebruikt om een unieke verhaspeling van een wachtwoord te maken, waardoor wachtwoorden uit elkaar gehouden kunnen worden zonder dat ze open en bloot bewaard moeten worden.
  component-section
    div(slot='title') De dictionary-adt
    p
      | Een
      |
      em.term dictionary
      |
      | of
      |
      em.term associatieve rij
      |
      | is een adt waarin je met iedere unieke
      |
      em.term sleutel
      |
      | (
      em.term (search) key
      | ) telkens één vaste waarde kan ophalen.
      | Deze adt kan op allerlei manieren worden geïmplementeerd, waarvan de
      |
      em.term hashtabel
      |
      | de belangrijkste is.
    p OpenDSA maakt dit concept concreet in duidelijke Java-broncode.
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/Dictionary.html') 6.4. The Dictionary ADT
    component-section
      div(slot='title')
        a(href='https://ans.app/digital_test/assignments/297648/routing') Generic dictionaries (op Ans)
      component-exercise
  component-section
    div(slot='title') Hashen
    p
      | In de volgende video geeft Kevin Drumm een eenvoudige inleiding in hashen.
      | Hieruit haal je het overzicht over het thema hashen.
    p.bron Hash Tables and Hash Functions
    component-video(videoid='KyUTuwz_b7Q', title='Hash Tables and Hash Functions')
    p
      | Hashen is dus een manier om een index te berekenen (met een
      |
      em.term hashfunctie
      | ) waarop je een stukje data kan vinden dat je zoekt, met een looptijd van \((O(1)\) in het gemiddelde geval, als je hashing goed implementeert).
    component-section
      div(slot='title')
        a(href='https://ans.app/digital_test/assignments/297651/routing') Slechte hashfunctie (op Ans)
      component-exercise
    p
      | Verder legde Kevin Drumm uit wat een hashtabel-datastructuur kan doen om om te gaan met
      |
      em.term botsingen
      |
      | (collisions: een sleutel blijkt niet uniek), onder de noemer
      |
      em.term collision resolution
      |
      | (botsingsoplossing).
      | Dat kan met
      |
      em.term open addressing
      | (bijvoorbeeld
      |
      em.term linear
      | of
      |
      em.term quadratic probing
      |
      | ) of
      |
      em.term closed addressing
      | /
      em.term separate chaining
      | .
    component-section
      div(slot='title')
        a(href='https://ans.app/digital_test/assignments/297656/routing') Belangrijkste eigenschappen hashfunctie (op Ans)
      component-exercise
    p OpenDSA legt hashing compleet uit.
    | Hieruit haal je diepgaande kennis.
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashIntro.html') 10.1. Introduction
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashFunc.html') 10.2. Hash Function Principles
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashFuncExamp.html') 10.3. Sample Hash Functions
    p
      | Om het ‘makkelijker te maken’ gebruiken informatici verwarrende synoniemen voor types collision resolution:
      |
      em.term closed hashing
      |
      | voor
      |
      em open addressing
      |
      | en
      |
      em.term open hashing
      |
      | is voor
      |
      em separate chaining
      | .
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/OpenHash.html') 10.4. Open Hashing
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/BucketHash.html') 10.5. Bucket Hashing
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashCSimple.html') 10.6. Collision Resolution
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashCImproved.html') 10.7. Improved Collision Resolution
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashAnal.html') 10.8. Analysis of Closed Hashing
    component-section
      div(slot='title')
        a(href='https://ans.app/digital_test/assignments/297658/routing') Load factor (op Ans)
      component-exercise
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashDel.html') 10.9. Deletion
